unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons, Math;

type

  TStr = array  of String;

  tTypes = (Lat, Lon, City, Country, Region, Look, ttNil);
  tFiles  = (Airports, ByAirports, byRegions, byCountry, Regions, RegStateCoICAO, WrkFile);
  tSpecial= (USCty,BazCty,ARGcty,CanCty,CuCty,BACty,POCTY,  MOCty, tsNil);

  PData = ^TData;
   TData = record
   ICAO        : String[8];
   Region      : String[3];
   Hash        : Double;
   HashStr     : String[12];
   City        : String[25];
   Country     : String[25];
   Lat         : Double;
   LatStr      : String[12];
   Lon         : Double;
   LonStr      : String[12];
   RCDLine     : String[95];
   Distance    : Double;
   DistanceStr : String[12];

   end;



  { TForm1 }

  TForm1 = class(TForm)
    btnICAOLookUp    : TBitBtn;
    btnClose         : TBitBtn;
    btnCalsDist      : TButton;
    btnCountNil      : TButton;
    btnSpecial       : TButton;
    btnSaveLB2       : TButton;
    btnChgCity       : TButton;
    BtnChgRegion     : TButton;
    btnChgCountry    : TButton;
    btnSaveCorrected : TButton;
    Button1          : TButton;
    Button2: TButton;
    btnTest: TButton;
    Edit1: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit12: TEdit;
    Edit13: TEdit;
    Edit14: TEdit;
    Edit15: TEdit;
    Edit16: TEdit;
    Edit17: TEdit;
    Edit18: TEdit;
    Edit19: TEdit;
    Edit2: TEdit;
    Edit20: TEdit;
    Edit21: TEdit;
    Edit22: TEdit;
    Edit23: TEdit;
    Edit24: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6        : TEdit;
    Edit7        : TEdit;
    Edit8        : TEdit;
    Edit9: TEdit;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    ListBox1: TListBox;
    ListBox2: TListBox;
    ListBox3: TListBox;
    ListBox4     : TListBox;
    ListBox5   : TListBox;

    procedure btnTestClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);



    procedure btnSaveCorrectedClick(Sender: TObject);
    procedure btnSaveLB2Click(Sender: TObject);


    procedure btnCalsDistClick(Sender: TObject);


    procedure btnChgCountryClick(Sender: TObject);
    procedure btnChgCityClick(Sender: TObject);
    procedure BtnChgRegionClick(Sender: TObject);
    procedure btnICAOLookUpClick(Sender: TObject);
    procedure btnCountNilClick(Sender: TObject);

    procedure Button1Click(Sender: TObject);




    Procedure Special;
    procedure btnSpecialClick(Sender: TObject);
    Procedure ChangeRecord(AIdx     : Integer; {Index to the Listbox2 Record}
                           AMode    : tTypes;  {Country, City or Region     }
                           ACountry : String;  {Country to Change To        }
                           ARegion  : String;  {Region ToChange To          }
                           ARCD     : String); {Record to Change in Listbox2}
    function SetCityCountry(AREgion : String) : Integer;


    procedure ListBox1Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);

    procedure ListBox2Click(Sender: TObject);
    procedure ListBox2DblClick(Sender: TObject);

    procedure ListBox3Click(Sender: TObject);
    procedure ListBox3DblClick(Sender: TObject);
    procedure ListBox5Click(Sender: TObject);

    Procedure LoadATextFile(Const aMode : tFiles; Const APath : String; aBox : TListBox);
    procedure WriteFile(aFile : String; aBox : TlistBox);
    procedure WriteCorrectedFile(aFile : String; ABOX : TlistBox);

    procedure CountNilsInLB2;


    function Decompose(aRCD : TData ) : TData;
    function CleanRecord (ARCD : TData) : Tdata;

    Procedure ReconstructRecord(AMODE   : TTypes;
                                AINDEX  : Integer;
                                NewItem : String;
                                ARcd    : String);

     function OneCalc(Const ARCD : TData) : TData;
     function DistanceBetweenLonLat(const Lat1, Lon1, Lat2, Lon2 : Extended): Extended;

     procedure StaticfDisplay(ARcd : TData; BRcd : TData);
     function SetDisplayLine(ALINE : String) : String;


  private

  public

  end;

Const
  Digits = ['0'..'9'];
  MaxDisplay = 20;
  C_ByRegion  = 'E:\Files\Region\MSTRegions.txt';
  C_ByAirport = 'E:\Files\Airports\ByAirport.txt';
  C_WorksFileAApList = 'E:\Files\Region\CountryRegion.txt';

var
  Form1: TForm1;
  DynamicRcd : TData;
  StaticRcd  : TData;
  Data       : Array of TData;
  DistData   : Array of TStr;

implementation
 uses strutils, LCLType;
{$R *.lfm}

//resourcestring
//  sSrcDefHint   = 'Double-click the item to decompose';
//  sClickAString = 'Please, double click in a string';
//  sfWithFloat = '%d = %s - As float: %f';
//  sfNoFloat   = '%d = %s';

{ TForm1 }

 procedure TForm1.FormCreate(Sender: TObject);
  var I : Integer = -1;
  begin
   Listbox2.Clear;
   if FileExists(C_ByAirport) then begin
      LoadATextFile(Airports,C_ByAirport,Listbox2); end;
    Listbox1.Clear;
   if FileExists(C_ByRegion) then begin
      LoadATextFile(Regions,C_ByRegion,Listbox1); end;
      Listbox5.Clear;
   if FileExists( C_WorksFileAApList) then begin
      LoadATextFile(WrkFile, C_WorksFileAApList,Listbox5); end;
   DynamicRcd := CleanRecord(DynamicRcd);
   DynamicRcd.RCDLine := Listbox1.Items[0];
   DynamicRcd := Decompose(DynamicRcd);
   Edit2.Text := Listbox1.Items[0];
   StaticRcd  := CleanRecord(StaticRcd);
   StaticRcd  :=  DynamicRcd;
   i := ListBox1.Items.Count;
   Edit13.Text := IntToStr(i);
   i := ListBox2.Items.Count;
   Edit15.Text := IntToStr(i);
   Listbox4.Clear;
  end;

 procedure TForm1.btnTestClick(Sender: TObject);
  Var FMT : String[40] = '';
    L1 : Integer = - 1;
    Bit1 : String = '';
    Bit2 : String = '';
    s1  : String = '[1][K1][13,000][KPHX][AUST]';
    //s2  : String = '[1][K4][295][KPHX][KLAS]';
    //s3  : String = '[1][6,043][KPHX][KHWI][PM]';
    //s4  : String = '[1][K7][495][KPHX][KABQ]';
    //s5  : String = '[1][K4][741][KPHX][KDEN]';
    //s6  : String = '[1][K1][13,000][KPHX][AUST]';
    //s7  : String = '[1][K1][13,000][KPHX][AUST]';
    //s8  : String = '[1][K1][13,000][KPHX][AUST]';
    //s9  : String = '[1][K1][13,000][KPHX][AUST]';
    //s10 : String = '[1][K1][13,000][KPHX][AUST]';
    //s11 : String = '[1][K1][13,000][KPHX][AUST]';
    //s12 : String = '[1][K1][13,000][KPHX][AUST]';
    //s13 : String = '[1][K1][13,000][KPHX][AUST]';
    //s14 : String = '[1][K1][13,000][KPHX][AUST]';
    //s15 : String = '[1][K1][13,000][KPHX][AUST]';
    //s16 : String = '[1][K1][13,000][KPHX][AUST]';

  begin
   FMT := SetDisplayLine(s1);
   Bit1 := ExtractWord(1,FMT,['[',']']);



   if Bit1 = '1' then begin
      ListBox4.Items.Add(Fmt);
      Bit1 := FMT;
      Bit2 := Copy2SpaceDel(Bit1);
      Bit1 := Trim(Bit1);
      Edit19.Text := Copy2SpaceDel(Bit1);
      Bit1 := Trim(Bit1);
      Edit20.Text := Copy2SpaceDel(Bit1);
      Bit1 := Trim(Bit1);
      Edit22.Text := Copy2SpaceDel(Bit1);
      Bit1 := Trim(Bit1);
      Edit23.Text := Copy2SpaceDel(Bit1);
   end;



  end;

  function TForm1.SetDisplayLine(ALINE : String) : String;
   {[1][K1][13,000][KPHX][AUST] }
   {         10        20   25    }
   {123456789012345678901234567890}
   {K1   13,000   KPHX   AUST     }

  Const
   SP1 = '    ';
   SP2 = '    ';
   Sp3 = '    ';
   Sp4 = '    ';
  Var i : Integer = -1;
    RCD      : String[40] = '';   {Result}
    LineNbr  : String[2] = '';    {Not Displayed}
    Region   : String[2] = '';
    Dist     : String[9] = '';
    FromICAO : String[6] = '';
    ToICAO   : String[4] = '';

   begin
    LineNbr := ExtractWord(1,ALINE,['[',']']);
    Region :=  ExtractWord(2,ALINE,['[',']']);
    Dist :=  ExtractWord(3,ALINE,['[',']']);
    FromICAO := ExtractWord(4,ALINE,['[',']']);
    TOICAO :=   ExtractWord(5,ALINE,['[',']']);
    RCD := '[' + LineNbr+ ']' + SP4 + Dist + SP1 + FromICAO + SP2 + TOICAO +  SP3 + Region;
    Result := RCD;
   end;

 procedure TForm1.btnSpecialClick(Sender: TObject);
  begin
    Special;
  end;

 {Custom code to perform easily corrected data
  often one time use code then rewriten for another
  one-off corection}
 Procedure Tform1.Special;
  Var i : Integer = -1;
   idx : Integer = -1;
   RLb5RCD     : String = '';
   RLb2RCD     : String = '';
   RLB5Region  : String[5]  = '';
   RLB5Country : String[25] = '';
   RLB5City    : String[25] = '';
   RLB2Region  : String[5]  = '';
   RLB2Country : String[25] = '';
   Mode1       : tSpecial;
   Mode2       : TTypes;
   Bit1        : String = '';
   Bit2        : String = '';
   StartingAt  : Integer = 0;
   begin
  { tTypes = (Lat, Lon, City, Country, Region, Look, ttNil);
    tSpecial= (USCty,BazCty,ARGcty,CanCty,CuCty,BACty,POCTY,  MOCty, tsNil);
  }
    for i := 0 to Listbox5.Items.Count -1 do begin
        Mode1 := tsNil;
        Mode2 := ttNil;
        ListBox5.ItemIndex := i;
        if i = -1 then begin exit; end;
        RLb5RCD := ListBox5.Items[i];
        Bit1 := RLb5RCD;
        Bit2 :=  Copy2SpaceDel(Bit1);
        Edit17.Text := Trim(Bit2);
        Edit18.Text := Trim(Bit1);

        ListBox5.TopIndex := -1 + ListBox5.Items.Count;
        Listbox5.TopIndex := Listbox5.ItemIndex;
        Listbox5.SetFocus;
        ListBox5.ItemIndex:= i;
        ListBox5.TopIndex := -1 + ListBox5.Items.Count;
        Listbox5.TopIndex := Listbox5.ItemIndex;
        Listbox5.SetFocus;

        RLB5Region := Edit17.Text;
        RLB5Region := Trim(RLB5Region);
        IDX := SetCityCountry(RLB5Region);
        if IDX = -1 then begin Break; end;
        RLb2RCD := ListBox2.Items[IDX];
        RLB2Region  := RLB5Region;                        {Match on Region}
        RLB2Country := ExtractWord(4,RLB2RCD,['[',']']);  {Not Nil}
// tTypes = (Lat, Lon, City, Country, Region, Look, ttNil);
        Edit12.Text := RLB2Country;

        Bit1 := '';


        ListBox5.Clear;
        Edit1.Text := ListBox2.Items[Idx];
        //DynamicRcd
          exit;
        ChangeRecord(i,
                     Country,
                     RLB2Country,
                     RLB2Region,
                     RLb2RCD);

        Application.ProcessMessages;
       end;
        ListBox5.ItemIndex := 0;
        Listbox5.SetFocus;
        ListBox5.Selected[0] := False;
     end;

  Procedure TForm1.ChangeRecord(AIdx     : Integer; {Index to the Listbox2 Record}
                                AMode    : tTypes;  {Country, City or Region     }
                                ACountry : String;  {Country to Change To        }
                                ARegion  : String;  {Region ToChange To          }
                                ARCD     : String); {Record to Change in Listbox2}
  Var i : Integer = -1;
   OrginalRCD  : String = '';
   RLB2RCD     : String = '';
   RLB2Region  : String = '';
   RLB2City    : String = '';
   RLB2Country : String = '';
   ItsAGo      : Boolean = False;
   begin
    OrginalRCD := ARCD;
    for i := 0 to  Listbox2.Items.Count -1 do begin
        ItsAGo      := False;
        RLB2RCD     := Listbox2.Items[i];
        RLB2City    := ExtractWord(3,RLB2RCD,['[',']']);
        RLB2Country := ExtractWord(4,RLB2RCD,['[',']']);
        RLB2Region  := ExtractWord(5,RLB2RCD,['[',']']);
        if (AMode = Country) and (RLB2Country <> 'Nil') then begin AMode := tTNil; end;


    Case AMode of
     City       : ItsAGo := False;
     Country    : btnChgCountryClick(Nil);
     Region     : ItsAGo := False;
     TTNil      : ItsAGo := False;
    end;
   end;
  end;

  function TForm1.SetCityCountry(AREgion : String) : Integer;
   Var i : Integer = -1;
    II : Integer = -1;
     RLB2RCD     : String = '';
     RLB2Country : String[25] = '';
     RLB2Region  : String[25] = '';
    begin
     Result := ii;
     {00FD][7255047][Riverview][United States][Nil][28.84665027][-82.34537195]}
     for i := 0 to Listbox2.Items.Count -1 do begin
       RLB2RCD     := Listbox2.Items[i];
       RLB2Country := ExtractWord(4,RLB2RCD,['[',']']);
       RLB2Region  := ExtractWord(5,RLB2RCD,['[',']']);
       if (ARegion = RLB2Region)And
          (RLB2Country <> 'Nil') then begin
          ii := i;
          Result := ii;
          break;
     end;

    end;
     Result := ii;
   end;











 procedure TForm1.btnCalsDistClick(Sender: TObject);
  Var RCD : TData;
   RCDString  : String = '';
   RLB2Lat    : String = '';
   AWord      : String = '';
   AFloat     : Double =0;
   LatLon     : Extended=0;
   Valid      : Boolean = False;
  begin
   RCDString := Edit1.Text;
   RCD := CleanRecord(RCD);
   if RCDString.IsEmpty then begin exit end;
   AWord := ExtractWord(6,RCDString, ['[',']']);
   Valid := TryStrToFloat(AWord, AFloat);
   if (Not Valid) or (AFloat = 0 ) then begin exit; end;
   RCD.RCDLine := Trim(RCDString);
   RCD := Decompose(RCD);
   RCD := OneCalc(RCD);

  //tFiles  = (Airports, ByAirports, byRegions, byCountry, Regions, RegStateCoICAO, WrkFile);
  //tSpecial= (USCty,BazCty,ARGcty,CanCty,CuCty,BACty,POCTY,  tNil);
   StaticfDisplay(StaticRcd,RCD);
  end;

 {Performs one Haverstine Calculation which measures
  the distance from one Latatude/Longatude  to a second
  Latatude/Longatude from any two points on the third rock
  from the Sun}
  function TForm1.OneCalc(Const ARCD : TData) : TData;
   Var
    RCD : TData;
    Dist : Double = 0;
    DistR : Double = 0;  {Rounded}
    Lat1 : Double = 0;
    Lon1 : Double = 0;
    Lat2 : Double = 0;
    Lon2 : Double = 0;
   begin
    RCD := ARCD;
    if DynamicRcd.Lat = 0 then begin
       DynamicRcd := CleanRecord(DynamicRcd);
       Edit2.Text :=  Listbox3.Items[0];
       DynamicRcd.RCDLine := Listbox3.Items[0];
       DynamicRcd := Decompose(DynamicRcd); end;
    {To Destination Set}
    Lat2 := RCD.Lat;
    Lon2 := RCD.Lon;
    {RefData Set}
    Lat1 := DynamicRcd.Lat;
    Lon1 := DynamicRcd.Lon;
    Dist := DistanceBetweenLonLat(Lat1, Lon1, Lat2, Lon2);
    DistR := Round(Dist);
    RCD.Distance := Round(DistR);
    RCD.DistanceStr := FloatToStr(DistR);
    DynamicRcd.Distance := Round(DistR);
    DynamicRcd.DistanceSTR := RCD.DistanceStr;
    StaticRcd := DynamicRcd;
    Result := RCD;
   end;

 {Part of the Haverstine Calculation which measures}
 function TForm1.DistanceBetweenLonLat(const Lat1, Lon1, Lat2, Lon2 : Extended): Extended;
  begin
   Result := RadToDeg(ArcCos(Sin(DegToRad(Lat1)) * Sin(DegToRad(Lat2)) + Cos(DegToRad(Lat1)) * Cos(DegToRad(Lat2)) * Cos(DegToRad(Lon1 - Lon2)))) * 69.09;
  end;

 {Fille out the Labels on the the Main Form }
 procedure TForm1.StaticfDisplay(ARcd : TData; BRcd : TData);
  Const Space1 = '     ';
   Space2 = '     ';
   Space3 = '     ';
  Var LB4String : String;
  begin
   Edit7.Text  := StaticRcd.ICAO;
   Edit5.Text  := StaticRcd.City;
   Edit6.Text  := StaticRcd.Country;
   Edit8.Text  := StaticRcd.LatStr;
   Edit9.Text  := StaticRcd.LonStr;
   Edit10.Text := StaticRcd.Region;
   Edit14.Text := StaticRcd.DistanceStr;
   if Listbox4.Items.Count < 11 then begin
      LB4String := StaticRcd.DistanceStr
                 + Space1  + StaticRcd.ICAO
                 + Space2  + BRcd.ICAO
                 + Space3  + StaticRcd.Region;
      // Needs a sort Highest to lowest
      ListBox4.Items.Add(LB4String);
   end;
  end;

 {Allows for the change of the country in a record in      TStringArray
  in listbox2}
 procedure TForm1.btnChgCountryClick(Sender: TObject);
   Var i : Integer = -1;
    lb2Text : String = '';
    Mode    : TTypes = Country;
    LB2RCD  : String = '';
  begin
   lb2text := Edit12.Text;
   if (lb2text.IsEmpty) OR (lb2Text = 'Enter Country') then begin exit; end;
   i := ListBox2.ItemIndex;
   Edit1.Text := ListBox2.Items[i];
   if i <> -1 then begin Lb2Rcd := Listbox2.Items[i]; end;
   ReconstructRecord( Mode, i, lb2Text , Lb2Rcd);
  end;

 {Allows for the change of the city in a record in
  in listbox2}
 procedure TForm1.btnChgCityClick(Sender: TObject);
  Var i : Integer = -1;
   lb2Text : String = '';
   Mode    : TTypes = City;
   LB2RCD  : String = '';
  begin
   lb2text := Edit11.Text;
   if (lb2text.IsEmpty) OR (lb2Text = 'Enter City') then begin exit; end;
   i := ListBox2.ItemIndex;
   if i <> -1 then begin Lb2Rcd := Listbox2.Items[i]; end;
   ReconstructRecord( Mode, i, lb2Text , Lb2Rcd);
  end;

 {Allows for the change of the Region in a record in
  in listbox2}
 procedure TForm1.BtnChgRegionClick(Sender: TObject);
   Var i : Integer = -1;
   lb2Text : String = '';
   Mode    : TTypes = Region;
   LB2RCD  : String = '';
  begin
   lb2text := Edit10.Text;
   if (lb2text.IsEmpty) OR (lb2Text = 'Reg:') then begin exit; end;
   i := ListBox2.ItemIndex;
   if i <> -1 then begin Lb2Rcd := Listbox2.Items[i]; end;
   ReconstructRecord( Mode, i, lb2Text , Lb2Rcd);
  end;

 procedure TForm1.Button1Click(Sender: TObject);
begin
  Listbox4.Clear;
end;

 {When a Country, City or Region is change this procedurd
  Reconstructs the record and updates Listbox2}
 Procedure TForm1.ReconstructRecord(AMODE : TTypes; AINDEX : Integer; NewItem : String; ARcd : String);
  Var I : Integer = -1;
   Mode        : TTypes;
   OrgRCD      : String = '';
   Lb2RCD      : String[95] = '';
   RLB2ICAO    : String[8]  = '';
   RLB2Hash    : String[8]  = '';
   RLB2City    : String[25] = '';
   RLB2Country : String[25] = '';
   RLB2Region  : String[5]  = '';
   RLB2Lat     : String[15] = '';
   RLB2LON     : String[15] = '';
   FMT         : String = '';
    begin
     Mode := AMode;
     OrgRcd      := ARcd;
     Lb2RCD      := aRcd;
     RLB2ICAO    := ExtractWord(1,Lb2RCD, ['[',']']);
     RLB2Hash    := ExtractWord(2,Lb2RCD, ['[',']']);
     RLB2City    := ExtractWord(3,Lb2RCD, ['[',']']);
     RLB2Country := ExtractWord(4,Lb2RCD, ['[',']']);
     RLB2Region  := ExtractWord(5,Lb2RCD, ['[',']']);
     RLB2Lat     := ExtractWord(6,Lb2RCD, ['[',']']);
     RLB2Lon     := ExtractWord(7,Lb2RCD, ['[',']']);
     Case Mode of
      City     : RLB2City := NewItem;
      Country  : RLB2Country := Newitem;
      Region   : RLB2Region := NewItem;
     end;
      FMT :=   '[' + RLB2ICAO    + ']'
             + '[' + RLB2Hash    + ']'
             + '[' + RLB2City    + ']'
             + '[' + RLB2Country + ']'
             + '[' + RLB2Region  + ']'
             + '[' + RLB2Lat     + ']'
             + '[' + RLB2Lon     + ']';
       i := ListBox2.Items.IndexOf(OrgRcd);
       ListBox2.Items.Strings[i] := (FMT);
    end;

 procedure TForm1.ListBox1Click(Sender: TObject);
  begin
   ListBox1DblClick(Nil);
  end;

 procedure TForm1.ListBox1DblClick(Sender: TObject);
  Var i : Integer = 0;
  begin
   DynamicRcd := CleanRecord(DynamicRcd);
   i := ListBox1.ItemIndex;
   if i <> -1 then begin
      DynamicRcd.RCDLine := Listbox1.Items[i];
      DynamicRcd := Decompose(DynamicRcd);
      StaticRcd := DynamicRcd;
      Edit2.Text := Listbox1.Items[i]; end;
   if i = -1 then begin ShowMessage('In LB1DblClick i = -1'); end;
  end;

 procedure TForm1.ListBox2Click(Sender: TObject);
 begin
  ListBox2DblClick(Nil);
 end;

 procedure TForm1.ListBox2DblClick(Sender: TObject);
  Var i : Integer = -1;
 begin
   i := ListBox2.ItemIndex;
   if i <> -1 then begin
      ListBox2.ItemIndex := i;
      ListBox2.TopIndex := -1 + ListBox2.Items.Count;
      Listbox2.TopIndex := Listbox2.ItemIndex;
      Listbox2.SetFocus;
      Edit1.Text := Listbox2.Items[i];

      ListBox3.ItemIndex := i;
      ListBox3.TopIndex := -1 + ListBox3.Items.Count;
      Listbox3.TopIndex := Listbox3.ItemIndex;
      Listbox3.SetFocus;
    end;
   if i = -1 then begin ShowMessage('In LB2DblClick i = -1'); end;
 end;

 procedure TForm1.ListBox3Click(Sender: TObject);
  begin
   ListBox3DblClick(Nil);
  end;

 procedure TForm1.ListBox3DblClick(Sender: TObject);
  Var i : Integer = 0;
 begin
   i := ListBox3.ItemIndex;
   if i <> -1 then begin
      ListBox3.TopIndex := -1 + ListBox3.Items.Count;
      Listbox3.TopIndex := Listbox3.ItemIndex;
      Listbox3.SetFocus;
      ListBox2.ItemIndex:= i;
      ListBox2.TopIndex := -1 + ListBox2.Items.Count;
      Listbox2.TopIndex := Listbox2.ItemIndex;
      Listbox2.SetFocus;
   end;
 end;

 procedure TForm1.ListBox5Click(Sender: TObject);
  Var i : Integer = 0;
   LB5RCD : String = '';
   iRegion : String = '';
   iCountry : String ='';
   Bit1 : String = '';
 begin
  i := ListBox5.ItemIndex;
  if i <> -1 then begin
     LB5RCD := ListBox5.Items[i];
     ListBox5.TopIndex := -1 + ListBox5.Items.Count;
     Listbox5.TopIndex := Listbox5.ItemIndex;
     Listbox5.SetFocus;
     ListBox5.ItemIndex:= i;
     ListBox5.TopIndex := -1 + ListBox5.Items.Count;
     Listbox5.TopIndex := Listbox5.ItemIndex;
     Listbox5.SetFocus;
     Edit17.Text := Copy2Space(LB5RCD);
     Edit18.Text := ExtractWord(2,LB5RCD,[' ']);
     Bit1 := Copy2SpaceDel(LB5RCD);
     Edit21.Text := Bit1;
     Bit1 := Trim(LB5RCD);
     Edit24.Text := Bit1;
   end;
 end;

 function TForm1.Decompose(ARCD : TData ) : TData;
   var RCD : TData;
    Count  : Integer;
    AWord  : String;
    AFloat : Extended;
    Delims : TSysCharSet;
    RCDString : String[95];
    LatLon  : Extended;
   begin
    RCD := aRCD;
    Delims := ['[',']'];
    {Extract all words}
    RCDString := RCD.RCDLine;
    Count := 0;
    repeat
      Inc(Count);
     //﻿RCDString := '[00VA][5890633][Alton][United States][K6][36.576][-78.999166667]';
      AWord := ExtractWord(Count, RCDString, Delims);
      if TryStrToFloat(AWord, AFloat) then  begin LatLon := AFloat; end;
       Case Count of
        0  : ShowMessage('Bad Data  in RCD in Decompose Function');
        1  : RCD.ICAO := AWord;
        2  : begin
             RCD.Hash := LatLon;
             RCD.HashStr := FloatToStr(LatLon);
             end;
        3  :  RCD.City :=  AWord;
        4  :  RCD.Country := AWord;
        5  :  RCD.Region := AWord;
        6  :  Begin
               RCD.Lat := LatLon;
               RCD.LatStr := FloatToStr(LatLon);
              end;
        7  :  Begin
               RCD.Lon := LatLon;
               RCD.LonStr := FloatToStr(LatLon);
              end;
       end;
    until AWord.IsEmpty;
    Result := RCD;
  end;

 function TForm1.CleanRecord (ARCD : TData) : Tdata;
  Var RCD : TData;
  begin
   RCD.ICAO:='';
   RCD.Region:='';
   RCD.Hash:=0;
   RCD.HashStr:='0';
   RCD.City:='';
   RCD.Country:='';
   RCD.Lat:=0;
   RCD.LatStr:='0';
   RCD.Lon:=0;
   RCD.LonStr:='0';
   RCD.RCDLine:='';
   RCD.Distance:=0;
   RCD.DistanceStr:='0';
   Result :=RCD;
  end;

 procedure TForm1.btnICAOLookUpClick(Sender: TObject);
   Var i : Integer = -1;
   RLB3ICAO    : String[8]  = '';
  begin
    RLB3ICAO := Edit3.Text;
    i := Listbox3.Items.Indexof(RLB3ICAO);
    if i = -1 then begin exit; end;
    ListBox3.ItemIndex := i;
    i := ListBox3.ItemIndex;
    if i <> -1 then begin
      ListBox3.TopIndex := -1 + ListBox3.Items.Count;
      Listbox3.TopIndex := Listbox3.ItemIndex;
      Listbox3.SetFocus;

      ListBox2.ItemIndex:= i;
      ListBox2.TopIndex := -1 + ListBox2.Items.Count;
      Listbox2.TopIndex := Listbox2.ItemIndex;
      Listbox2.SetFocus;
  end;
 end;

 Procedure TForm1.LoadATextFile(Const aMode : tFiles; Const APath : String; aBox : TListBox);
   Const Space1 = '    ';
   var
    DataFile : TextFile;
    Line     : String = '';
    ICAO     : String = '';
    iCountry : String[25] = '';
    iRegion  : String[3] ='';
    FMT      : String = '';
 begin
  if not FileExists(aPath) then begin ShowMessage('File Not found'); exit; end;
   AssignFile(DataFile, aPath);
  try
    Reset(Datafile);
    try
      while not EoF(DataFile) do begin
        ReadLn(DataFile, Line);
        Line := Trim(Line);
        if aMode = Regions then
          begin
           aBox.Items.Add(Line);
        end;
         if aMode = Airports then begin
           ICAO := ExtractWord(1,Line,['[',']']);
           ICAO := Trim(ICAO);
           if ICAO.IsEmpty then begin Continue; end;
           if ICAO = '99'  then begin Continue; end;
           if ICAO.IsEmpty then begin Continue; end;
           Listbox3.Items.Add(ICAO);
           aBox.Items.Add(Line);
        end;
       if aMode = RegStateCoICAO then begin aBox.Items.Add(Line); end;

       if aMode = WrkFile  then begin
          iCountry := ExtractWord(1,Line,[',']);
          iRegion :=  ExtractWord(2,Line,[',']);
          FMT := IRegion + Space1 + iCountry;
          aBox.Items.Add(FMT);
       end;
      end;
     except ShowMessage('Error reading file:'); end;
  finally
    CloseFile(DataFile);
  end;
 end;

 procedure TForm1.btnSaveLB2Click(Sender: TObject);
   begin
    WriteFile(C_ByAirport,Listbox2);
   end;

 procedure TForm1.WriteFile(aFile : String; ABOX : TlistBox);
  Var i : integer = -1;
   OutFile : Textfile;
   Line    : String = '';
   begin
   if ListBox2.Items.Count = 0 then begin exit; end;
     AssignFile(OutFile, aFile);
     Try
       Rewrite(OutFile);
       for i := 0 to ABox.Items.Count-1  Do begin
          Line := ABOX.Items[i];
          Line := Trim(Line);
          WriteLn (Outfile,Line);
         end;
       finally
      CloseFile(OutFile);
     end;
    end;

 procedure TForm1.btnSaveCorrectedClick(Sender: TObject);
  begin
   WriteCorrectedFile(C_ByRegion,Listbox2);
  end;

 procedure TForm1.WriteCorrectedFile(aFile : String; ABOX : TlistBox);
  Var i : integer = -1;
   OutFile : Textfile;
   Line    : String = '';
   Present : Boolean = False;
   Test    : String[95];
   WriteCount : Integer = 0;
   begin
   if ListBox2.Items.Count = 0 then begin exit; end;
     AssignFile(OutFile, aFile);
     Try
       Rewrite(OutFile);
       for i := 0 to ABox.Items.Count-1  Do begin
          Line := ABOX.Items[i];
          Line := Trim(Line);
          Test := Line;
          Test := Uppercase(Test);
          Present := IsWordPresent('NIL', Test, ['[',']']);
          if Not Present then begin
             Inc(WriteCount);
             Edit16.Text := IntToStr(WriteCount);
             WriteLn (Outfile,Line); end;
           Application.ProcessMessages;
         end;
       finally
      CloseFile(OutFile);
     end;
    end;

 {Calls CountNilsInLB2. Could be eliminated but what the hell}
 procedure TForm1.btnCountNilClick(Sender: TObject);
  begin
   CountNilsInLB2;
  end;

 {Counts the "Nil's" in Listbox2 = Info only}
 procedure TForm1.CountNilsInLB2;
  Var i : Integer = -1;
   IDX : Integer = 0;
   RCDString   : String[95] = '';
   RLB2ICAO    : String[8]  = '';
   RLB2Hash    : String[8]  = '';
   RLB2City    : String[25] = '';
   RLB2Country : String[25] = '';
   RLB2Region  : String[5]  = '';
   RLB2Lat     : String[15] = '';
   RLB2LON     : String[15] = '';
  {[KPHX][4206231][Phoenix][United States][K2][33.434277778][-112.011583333]}
  begin
   for  i := 0 to  ListBox2.Items.Count -1 do begin
        RCDString := ListBox2.Items[i];
        RCDString := UpperCase(RCDString);
        RLB2ICAO  := ExtractWord(1,RCDString, ['[',']']);
        RLB2Hash := ExtractWord(2,RCDString, ['[',']']);
        RLB2City  := ExtractWord(3,RCDString, ['[',']']);
        RLB2Country := ExtractWord(4,RCDString, ['[',']']);
        RLB2Region := ExtractWord(5,RCDString, ['[',']']);
        RLB2Lat   := ExtractWord(6,RCDString, ['[',']']);
        RLB2Lon   := ExtractWord(7,RCDString, ['[',']']);
        if  RLB2ICAO = 'NIL' then begin Inc(IDX); end;
        if  RLB2Hash = 'NIL' then begin Inc(IDX); end;
        if  RLB2City = 'NIL' then begin Inc(IDX); end;
        if  RLB2Country = 'NIL' then begin Inc(IDX); end;
        if  RLB2Region = 'NIL' then begin Inc(IDX); end;
        if  RLB2Lat = 'NIL' then begin Inc(IDX); end;
        if  RLB2Lon = 'NIL' then begin Inc(IDX); end;
        INC(IDX);
        Edit4.Text := IntToStr(Idx);
        Application.ProcessMessages;
   end;
  end;

 {Clears the listboxes. Closes the program and
  crashes gracefully to the desktop}
 procedure TForm1.btnCloseClick(Sender: TObject);
  begin
    ListBox1.Clear;
    ListBox2.Clear;
    ListBox3.Clear;
    ListBox4.Clear;
    ListBox5.Clear;
    Close;
  end;

end.

